## deepin-terminal 6.0.14

=== CMakeLists.txt ===
project(deepin-terminal)

cmake_minimum_required(VERSION 3.9.5)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR})

include (GNUInstallDirs)
include (src/DtkSettingsToolsMacros)
option(TERM_RPATH "Do you want to use compiled libraries" ON)

if(TERM_RPATH)
  set(CMAKE_SKIP_INSTALL_RPATH YES)
  set(CMAKE_SKIP_RPATH YES)
endif()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(QT_MINIMUM_VERSION "5.7.1")

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif ()

#compile flags
if (CMAKE_BUILD_TYPE MATCHES Debug)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -Wextra")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wextra")

  # Enable Qt builtin debug mode
  add_definitions("-DQT_MESSAGELOGCONTEXT")
else()
  # -Wl, -O2 Enable linker optimizations
  # -Wl, --gc-sections
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
endif()

#Use deepin-turbo for Performance optimization
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--as-needed -fPIE")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pie")
#安全编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")

configure_file(src/environments.h.in environments.h @ONLY)

#代码覆盖率开关
if(CMAKE_COVERAGE_ARG STREQUAL "CMAKE_COVERAGE_ARG_ON")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
endif()

# Find the QtWidgets library

find_package(PkgConfig REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5LinguistTools REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5X11Extras REQUIRED)

include(FindPkgConfig)
include(FindFontconfig)

pkg_search_module(DtkWidget REQUIRED dtkwidget)
pkg_search_module(DtkGui REQUIRED dtkgui)
pkg_search_module(DtkCore REQUIRED dtkcore)
pkg_search_module(GOBJECT REQUIRED gobject-2.0)
pkg_check_modules(LIBSECRET REQUIRED libsecret-1)
pkg_check_modules(XCB_EWMH REQUIRED xcb-ewmh x11)

# Compile definitions for TerminalWidget
# So we can use QT_VERSION_CHECK
set(TERMINALWIDGET_VERSION_MAJOR "0")
set(TERMINALWIDGET_VERSION_MINOR "14")
set(TERMINALWIDGET_VERSION_PATCH "1")

add_subdirectory(3rdparty/terminalwidget)

include_directories(${DtkWidget_INCLUDE_DIRS})
include_directories(${DtkGui_INCLUDE_DIRS})
include_directories(${DtkCore_INCLUDE_DIRS})

include_directories("src/common")
include_directories("src/customcommand")
include_directories("src/encodeplugin")
include_directories("src/main")
include_directories("src/remotemanage")
include_directories("src/settings")
include_directories("src/views")
include_directories("3rdparty/terminalwidget/lib")

set(LINK_LIBS
    Qt5::Core
    Qt5::DBus
    Qt5::Widgets
    Qt5::WidgetsPrivate
    Qt5::Network

    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
    ${DtkGUI_LIBRARIES}
    ${GOBJECT_LIBRARIES}
    ${LIBSECRET_LIBRARIES}
    ${XCB_EWMH_LIBRARIES}
    ${Qt5X11Extras_LIBRARIES}
    ${Fontconfig_LIBRARIES}
)

# Populate a CMake variable with the sources
# TODO: portable headers?
set (DTNG_CPP_FILES
    src/common/utils.cpp
    src/common/settingio.cpp
    src/common/eventlogutils.cpp
    src/customcommand/customcommandoptdlg.cpp
    src/customcommand/customcommandpanel.cpp
    src/customcommand/customcommandplugin.cpp
    src/customcommand/customcommandsearchrstpanel.cpp
    src/customcommand/customcommandtoppanel.cpp
    src/encodeplugin/encodepanelplugin.cpp
    src/encodeplugin/encodepanel.cpp
    src/encodeplugin/encodelistview.cpp
    src/encodeplugin/encodelistmodel.cpp
    src/main/main.cpp
    src/main/service.cpp
    src/main/windowsmanager.cpp
    src/main/mainwindow.cpp
    src/main/terminalapplication.cpp
    src/main/termproperties.cpp    
    src/main/dbusmanager.cpp
    src/remotemanage/groupconfigoptdlg.cpp
    src/remotemanage/remotemanagementpanel.cpp
    src/remotemanage/remotemanagementplugn.cpp
    src/remotemanage/remotemanagementsearchpanel.cpp
    src/remotemanage/remotemanagementtoppanel.cpp
    src/remotemanage/serverconfiggrouppanel.cpp
    src/remotemanage/serverconfigmanager.cpp
    src/remotemanage/serverconfigoptdlg.cpp
    src/settings/newdspinbox.cpp
    src/settings/settings.cpp
    src/settings/settings_translation.cpp
    src/settings/shortcutmanager.cpp
    src/views/commonpanel.cpp
    src/views/pagesearchbar.cpp
    src/views/rightpanel.cpp
    src/views/tabbar.cpp
    src/views/tabrenamedlg.cpp
    src/views/tabrenamewidget.cpp
    src/views/termwidget.cpp
    src/views/termwidgetpage.cpp
    src/views/termbasedialog.cpp
    src/views/termcommandlinkbutton.cpp
    src/views/titlebar.cpp
    src/views/itemwidget.cpp
    src/views/focusframe.cpp
    src/views/iconbutton.cpp
    src/views/listview.cpp
    src/views/customthemesettingdialog.cpp
    src/views/themepreviewarea.cpp
    src/views/switchthememenu.cpp
)

set (DTNG_HEADER_FILES
    src/common/define.h
    src/common/utils.h
    src/common/settingio.h
    src/common/eventlogutils.h
    src/customcommand/customcommandoptdlg.h
    src/customcommand/customcommandpanel.h
    src/customcommand/customcommandplugin.h
    src/customcommand/customcommandsearchrstpanel.h
    src/customcommand/customcommandtoppanel.h
    src/encodeplugin/encodepanelplugin.h
    src/encodeplugin/encodepanel.h
    src/encodeplugin/encodelistview.h
    src/encodeplugin/encodelistmodel.h
    src/main/windowsmanager.h
    src/main/mainwindow.h
    src/main/mainwindowplugininterface.h
    src/main/service.h
    src/main/terminalapplication.h
    src/main/termproperties.h
    src/main/dbusmanager.h
    src/remotemanage/remotemanagementpanel.h
    src/remotemanage/remotemanagementplugn.h
    src/remotemanage/remotemanagementsearchpanel.h
    src/remotemanage/remotemanagementtoppanel.h
    src/remotemanage/serverconfiggrouppanel.h
    src/remotemanage/serverconfigmanager.h
    src/remotemanage/serverconfigoptdlg.h
    src/settings/newdspinbox.h
    src/settings/settings.h
    src/settings/shortcutmanager.h
    src/views/commonpanel.h
    src/views/pagesearchbar.h
    src/views/rightpanel.h
    src/views/tabbar.h
    src/views/tabrenamedlg.h
    src/views/tabrenamewidget.h
    src/views/termwidget.h
    src/views/termwidgetpage.h
    src/views/titlebar.h
    src/views/termbasedialog.h
    src/views/termcommandlinkbutton.h
    src/views/itemwidget.h
    src/views/focusframe.h
    src/views/iconbutton.h
    src/views/listview.h
    src/views/customthemesettingdialog.h
    src/views/themepreviewarea.h
    src/views/switchthememenu.h
)

set (DTNG_QRC_FILES
    src/assets/resources.qrc
)

# Program
set (EXE_NAME deepin-terminal)

# Translation
file (GLOB DTNG_TS_FILES translations/*.ts)
set (DTNG_CPP_FILES_FOR_I18N ${DTNG_CPP_FILES})

dtk_create_i18n_from_json(DTNG_SETTINGS_I18N_FILES default-config.json settings_translation.cpp)
list (APPEND DTNG_CPP_FILES_FOR_I18N ${DTNG_SETTINGS_I18N_FILES})
qt5_create_translation(DTNG_QM_FILES ${DTNG_CPP_FILES_FOR_I18N} ${DTNG_TS_FILES})

add_executable (${EXE_NAME}
    ${DTNG_HEADER_FILES}
    ${DTNG_CPP_FILES}
    ${DTNG_QRC_FILES}
    ${DTNG_QM_FILES}
)

target_include_directories(${EXE_NAME} PUBLIC ${Qt5Widgets_LIBRARIES}
                                              ${Qt5DBus_LIBRARIES}
                                              ${Qt5Widgets_PRIVATE_INCLUDE_DIRS}
                                              ${Qt5Core_PRIVATE_INCLUDE_DIRS}
                                              ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
                                              ${PROJECT_BINARY_DIR}
                                              ${DtkWidget_INCLUDE_DIRS}
                                              ${DtkCore_LIBRARIES}
                                              ${DtkGUI_INCLUDE_DIRS}
                                              ${GOBJECT_INCLUDE_DIRS}
                                              ${LIBSECRET_INCLUDE_DIRS}
                                              ${XCB_EWMH_INCLUDE_DIRS})

target_link_libraries (deepin-terminal ${LINK_LIBS} terminalwidget5)

# Installation

#install(TARGETS deepin-terminal DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-terminal)

install(FILES src/deepin-terminal.desktop
	DESTINATION ${CMAKE_INSTALL_DATADIR}/applications/)

install(FILES src/assets/logo/deepin-terminal.svg
	DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps/)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/deepin-terminal
        DESTINATION ${CMAKE_INSTALL_BINDIR}
        PERMISSIONS OWNER_READ OWNER_EXECUTE
        GROUP_READ GROUP_EXECUTE
        WORLD_READ WORLD_EXECUTE)

install(FILES ${DTNG_QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-terminal/translations)

install(DIRECTORY src/assets/deepin-terminal
        DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-manual/manual-assets/application/)

# Unit Test
if (CMAKE_BUILD_TYPE MATCHES Debug)
  add_subdirectory(tests)
endif()

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

project(deepin-terminal-test)

configure_file(../src/environments.h.in environments.h @ONLY)

# 设置添加gocv相关信息的输出
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fprofile-arcs -ftest-coverage -fno-inline")
#安全编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(PROJECT_NAME_TEST ${PROJECT_NAME})

add_compile_options(-fno-access-control)

find_package(Qt5Test REQUIRED)
find_package(GTest REQUIRED)

add_definitions(${Qt5Test_DEFINITIONS})
add_definitions(-D UNIT_TEST)

include_directories(${GTEST_INCLUDE_DIRS})
include_directories("src/common")
include_directories("src/customcommand")
include_directories("src/encodeplugin")
include_directories("src/remotemanage")
include_directories("src/views")
include_directories("src/main")
include_directories("src/3rdparty/terminalwidget/lib/")
include_directories("src/3rdparty/terminalwidget/lib/history")
include_directories("src/3rdparty/terminalwidget/lib/history/compact")

FILE(GLOB allSource
    ../src/common/*.cpp
    ../src/customcommand/*.cpp
    ../src/encodeplugin/*.cpp
    ../src/remotemanage/*.cpp
    ../src/settings/*.cpp
    ../src/views/*.cpp
    ../src/main/service.cpp
    ../src/main/windowsmanager.cpp
    ../src/main/mainwindow.cpp
    ../src/main/terminalapplication.cpp
    ../src/main/termproperties.cpp
    ../src/main/dbusmanager.cpp
)

FILE(GLOB allHeaders
    ../src/common/*.h
    ../src/customcommand/*.h
    ../src/encodeplugin/*.h
    ../src/main/*.h
    ../src/remotemanage/*.h
    ../src/settings/*.h
    ../src/views/*.h
)

FILE(GLOB allThirdPartySource
    ../3rdparty/terminalwidget/lib/*.cpp
    ../3rdparty/terminalwidget/lib/history/*.cpp
    ../3rdparty/terminalwidget/lib/history/compact/*.cpp
)

FILE(GLOB qrcFiles
    ../src/assets/resources.qrc
)

FILE(GLOB allTestHeader
    src/common/*.h
    src/customcommand/*.h
    src/encodeplugin/*.h
    src/main/*.h
    src/remotemanage/*.h
    src/settings/*.h
    src/views/*.h
    src/3rdparty/terminalwidget/lib/*.h
)

FILE(GLOB allTestSource
    src/common/*.cpp
    src/customcommand/*.cpp
    src/encodeplugin/*.cpp
    src/main/*.cpp
    src/remotemanage/*.cpp
    src/settings/*.cpp
    src/views/*.cpp
)

set(UI ../3rdparty/terminalwidget/lib/SearchBar.ui)
qt5_wrap_ui(UI_SRCS ${UI})

set(KB_LAYOUT_DIR "${CMAKE_INSTALL_FULL_DATADIR}/${TERMINALWIDGET_LIBRARY_NAME}/kb-layouts")
set(COLORSCHEMES_DIR "${CMAKE_INSTALL_FULL_DATADIR}/${TERMINALWIDGET_LIBRARY_NAME}/color-schemes")
set(TRANSLATIONS_DIR "${CMAKE_INSTALL_FULL_DATADIR}/${TERMINALWIDGET_LIBRARY_NAME}/translations")

add_definitions("-DHAVE_POSIX_OPENPT")
add_definitions("-DKB_LAYOUT_DIR=\"${KB_LAYOUT_DIR}\"")
add_definitions("-DCOLORSCHEMES_DIR=\"${COLORSCHEMES_DIR}\"")
add_definitions("-DTRANSLATIONS_DIR=\"${TRANSLATIONS_DIR}\"")

add_executable(${PROJECT_NAME_TEST}
    ${UI_SRCS}
    ${allThirdPartySource}
    ${allHeaders}
    ${allSource}
    ${allTestHeader}
    ${allTestSource}
    ${qrcFiles}
    ${uiFiles}
)

target_include_directories(${PROJECT_NAME_TEST} PUBLIC ${Qt5Widgets_LIBRARIES}
                                                        ${Qt5DBus_LIBRARIES}
                                                        ${Qt5TestLib_LIBRARIES}
                                                        ${Qt5Widgets_PRIVATE_INCLUDE_DIRS}
                                                        ${Qt5Core_PRIVATE_INCLUDE_DIRS}
                                                        ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
                                                        ${PROJECT_BINARY_DIR}
                                                        ${DtkWidget_INCLUDE_DIRS}
                                                        ${DtkCore_LIBRARIES}
                                                        ${DtkGUI_INCLUDE_DIRS}
                                                        ${GOBJECT_INCLUDE_DIRS}
                                                        ${LIBSECRET_INCLUDE_DIRS})

target_link_libraries(${PROJECT_NAME_TEST} PUBLIC ${LINK_LIBS} Qt5::Test ${GTEST_LIBRARIES} ${GTEST_MAIN_LIBRARIES} -lpthread -lm)

#------------------------------ 创建'make test'指令---------------------------------------
add_custom_target(test
#    #执行mkdir -p 创建 coverageResult
#    COMMAND mkdir -p coverageResult
#    #设置工作目录
#    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)

add_custom_command(TARGET test
    COMMAND ${CMAKE_BINARY_DIR}/tests/${PROJECT_NAME_TEST}
)

#'make test'命令依赖与我们的测试程序
add_dependencies(test ${PROJECT_NAME_TEST})

#ASAN安全性检测标志
set(CMAKE_SAFETYTEST "${CMAKE_SAFETYTEST_ARG}")
if(CMAKE_SAFETYTEST STREQUAL "")
    set(CMAKE_SAFETYTEST "CMAKE_SAFETYTEST_ARG_OFF")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D${CMAKE_SAFETYTEST}")
if(CMAKE_SAFETYTEST STREQUAL "CMAKE_SAFETYTEST_ARG_ON")
  #安全测试选项
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=undefined,address -O2")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=undefined,address -O2")
endif()

=== debian/changelog ===
deepin-terminal (6.0.14) unstable; urgency=medium

  * chore: Update translation (#346)

 -- Zhang Kun <zhangkun2@uniontech.com>  Thu, 01 Aug 2024 09:31:00 +0800

deepin-terminal (6.0.13) unstable; urgency=medium

  * fix: Remote server item text overlaps with buttons
    新增Ctrl + 鼠标点击移动光标功能
    为Ctrl+鼠标左键点击移动光标功能新增配置
    fix: item is hidden partially in settingsdialog
    fix: Bug# 点击自定义主题后未确认，菜单勾选状态错误
    更新退出终端的警告弹窗提示语

 -- Yutao Meng <mengyutao@deepin.org>  Fri, 21 Jun 2024 13:41:33 +0800

deepin-terminal (6.0.12) unstable; urgency=medium

  * fix: the quake window overlaps with the dock (Issue: #6557)
  * feat: load keyboard layouts from runtime dir first
  * fix: cursor position error when display completion (Issue: #5208)
  * fix: local keytab logic error
  * feat: Supports dsg-terminal-exec scheme (Issue: #7439)

 -- Wang Yixue <wangyixue@deepin.org>  Tue, 12 Mar 2024 10:06:23 +0800

deepin-terminal (6.0.11) unstable; urgency=medium

  * 改用DTK方式启动文管，避免AM给文管套终端的appid,影响主题。

 -- Yutao Meng <mengyutao@deepin.org>  Thu, 01 Feb 2024 10:28:53 +0800

deepin-terminal (6.0.10) unstable; urgency=medium

  * 调换切换前后标签页快捷键为正确顺序
    修复雷神窗口无法设置模糊的问题
    Dirty Fix改为部分刷新光标后的显示问题
    无法打开未以'/'结尾的带端口号的链接
    Fix debug logs spaming problem while resizing

 -- Yutao Meng <mengyutao@deepin.org>  Thu, 25 Jan 2024 11:35:43 +0800

deepin-terminal (6.0.9) unstable; urgency=medium

  * Fix abnormal animations of quake window under multi-monitor scenario.
    Fix wrong title bar previews of dark/light themes in system themes.

 -- Yutao Meng <mengyutao@deepin.org>  Fri, 03 Nov 2023 10:38:56 +0800

deepin-terminal (6.0.8) unstable; urgency=medium

  * Allow extending terminal themes
    Fix wrong width of Quake window if opened in a secondary screen with
    different resolution with main screen

 -- Yutao Meng <mengyutao@deepin.org>  Tue, 17 Oct 2023 10:39:37 +0800

deepin-terminal (6.0.7) unstable; urgency=medium

  * Fix compilation errors on deepin V23.
    Add tips for empty group section in add server dialog.

 -- Yutao Meng <mengyutao@deepin.org>  Mon, 28 Aug 2023 15:03:01 +0800

deepin-terminal (6.0.6) unstable; urgency=medium

  * Feature:
      Optimized remote server functions
      Update window title according to current tab name
      New cursor type of bold underline
      New option to choose which special characters to be included in double
click selections
      Change opacity with "Shift+Ctrl+Mouse Wheel"
    Fix Bugs:
      Better implementation of enable/disable flow control feature
      Fix "Desktop Action" sections of desktop entry file to freedesktop standards
      Blacklist Noto Sans SignWriting fonts
      Fix compilation error
      Fix Shift+Tab shortcut is unusable in terminal shells
      Remove dependencies on dde-daemon WMSwitcher
      Remove useless desktop environment variable


 -- Yutao Meng <mengyutao@deepin.org>  Tue, 01 Aug 2023 16:37:36 +0800

deepin-terminal (6.0.5) unstable; urgency=medium

  * Feature:
	New setting for customizing history line size

    Fix Bugs:
	Quake window animation is extremely slow by default.
	The translations of "Ctrl+Mouse Scroll" setting entry is missing.
	Font list in settings is empty on other distributions.

 -- mengyutao <mengyutao@uniontech.com>  Thu, 16 Mar 2023 09:32:20 +0800

deepin-terminal (6.0.4) unstable; urgency=medium

  * Add option to control the length of Quake window animation (#252)
    Autohide titlebar on fullscreen mode (#253)

 -- mengyutao <mengyutao@uniontech.com>  Wed, 22 Feb 2023 15:48:20 +0800

deepin-terminal (6.0.3) unstable; urgency=medium

  * update version

 -- liuzheng <liuzheng@uniontech.com>  Mon, 16 Jan 2023 16:43:01 +0800

deepin-terminal (6.0.2) unstable; urgency=medium

  * update version

 -- liuzheng <liuzheng@uniontech.com>  Mon, 16 Jan 2023 14:39:13 +0800

deepin-terminal (6.0.1) unstable; urgency=medium

  * New version 6.0.1

 -- hemingyang <hemingyang@uniontech.com>  Wed, 09 Nov 2022 15:22:05 +0800

## deepin-terminal 6.0.15

=== debian/changelog ===
deepin-terminal (6.0.15) unstable; urgency=medium

  * Release 6.0.15
  * feat: [UI] Adapt compact mode.(https://pms.uniontech.com/bug-view-279709.html)

 -- Zhang Kun <zhangkun2@uniontech.com>  Fri, 25 Oct 2024 18:09:30 +0800

## deepin-terminal 6.0.16

=== CMakeLists.txt ===
--- 
+++ 
@@ -277,8 +277,3 @@
 
 install(DIRECTORY src/assets/deepin-terminal
         DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-manual/manual-assets/application/)
-
-# Unit Test
-if (CMAKE_BUILD_TYPE MATCHES Debug)
-  add_subdirectory(tests)
-endif()

=== 3rdparty/terminalwidget/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0 FATAL_ERROR)
# CMP0000: Call the cmake_minimum_required() command at the beginning of the top-level
# CMakeLists.txt file even before calling the project() command.
# The cmake_minimum_required(VERSION) command implicitly invokes the cmake_policy(VERSION)
# command to specify that the current project code is written for the given range of CMake
# versions.
project(terminalwidget)

include(GNUInstallDirs)
include(GenerateExportHeader)
include(CMakePackageConfigHelpers)
include(CheckFunctionExists)
include(CheckIncludeFile)

option(UPDATE_TRANSLATIONS "Update source translation translations/*.ts files" OFF)
option(BUILD_EXAMPLE "Build example application. Default OFF." OFF)
option(TERMINALWIDGET_USE_UTEMPTER "Uses the libutempter library. Mainly for FreeBSD" OFF)
option(TERMINALWIDGET_BUILD_PYTHON_BINDING "Build python binding" OFF)
option(USE_UTF8PROC "Use libutf8proc for better Unicode support. Default OFF" OFF)


# just change version for releases
set(TERMINALWIDGET_VERSION_MAJOR "0")
set(TERMINALWIDGET_VERSION_MINOR "14")
set(TERMINALWIDGET_VERSION_PATCH "1")

set(TERMINALWIDGET_VERSION "${TERMINALWIDGET_VERSION_MAJOR}.${TERMINALWIDGET_VERSION_MINOR}.${TERMINALWIDGET_VERSION_PATCH}")

# additional cmake files
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake")
set(CMAKE_INCLUDE_CURRENT_DIR ON)


# Minimum Versions
set(QT_MINIMUM_VERSION "5.7.1")
set(LXQTBT_MINIMUM_VERSION "0.6.0")

find_package(Qt5Widgets "${QT_MINIMUM_VERSION}" REQUIRED)
find_package(Qt5LinguistTools "${QT_MINIMUM_VERSION}" REQUIRED)
find_package(lxqt-build-tools ${LXQTBT_MINIMUM_VERSION} REQUIRED)

if(USE_UTF8PROC)
    find_package(Utf8Proc REQUIRED)
endif()

#注释掉下面这行，否则无法支持命令行cmake构建
#include(LXQtPreventInSourceBuilds)
include(LXQtTranslateTs)
include(LXQtCompilerSettings NO_POLICY_SCOPE)
include(LXQtCreatePkgConfigFile)

if(APPLE)
    if(CMAKE_VERSION VERSION_GREATER 3.9)
        cmake_policy(SET CMP0068 NEW)
        set(CMAKE_BUILD_WITH_INSTALL_NAME_DIR ON)
    endif()
endif()

set(TERMINALWIDGET_LIBRARY_NAME terminalwidget5)

remove_definitions(-DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII -DQT_NO_CAST_FROM_BYTEARRAY)

# main library

set(SRCS
    lib/BlockArray.cpp
    lib/ColorScheme.cpp
    lib/CharacterFormat.cpp
    lib/Emulation.cpp
    lib/Filter.cpp
    lib/history/HistoryFile.cpp
    lib/history/HistoryScroll.cpp
    lib/history/HistoryScrollFile.cpp
    lib/history/HistoryScrollNone.cpp
    lib/history/HistoryType.cpp
    lib/history/HistoryTypeFile.cpp
    lib/history/HistoryTypeNone.cpp
    lib/history/compact/CompactHistoryScroll.cpp
    lib/history/compact/CompactHistoryType.cpp
    lib/HistorySearch.cpp
    lib/KeyboardTranslator.cpp
    lib/konsole_wcwidth.cpp
    lib/kprocess.cpp
    lib/kpty.cpp
    lib/kptydevice.cpp
    lib/kptyprocess.cpp
    lib/ProcessInfo.cpp
    lib/Pty.cpp
    lib/qtermwidget.cpp
    lib/Screen.cpp
    lib/ScreenWindow.cpp
    lib/SearchBar.cpp
    lib/Session.cpp
    lib/SessionManager.cpp
    lib/ShellCommand.cpp
    lib/TerminalCharacterDecoder.cpp
    lib/TerminalDisplay.cpp
    lib/tools.cpp
    lib/Vt102Emulation.cpp
    lib/EscapeSequenceUrlExtractor.cpp
)

# Only the Headers that need to be moc'd go here
set(HDRS
    lib/Emulation.h
    lib/Filter.h
    lib/history/HistoryFile.h
    lib/history/HistoryScroll.h
    lib/history/HistoryScrollFile.h
    lib/history/HistoryScrollNone.h
    lib/history/HistoryType.h
    lib/history/HistoryTypeFile.h
    lib/history/HistoryTypeNone.h
    lib/history/compact/CompactHistoryScroll.h
    lib/history/compact/CompactHistoryType.h
    lib/HistorySearch.h
    lib/kprocess.h
    lib/kptydevice.h
    lib/kptyprocess.h
    lib/ProcessInfo.h
    lib/Pty.h
    lib/qtermwidget.h
    lib/ScreenWindow.h
    lib/SearchBar.h
    lib/Session.h
    lib/SessionManager.h
    lib/TerminalDisplay.h
    lib/Vt102Emulation.h
    lib/EscapeSequenceUrlExtractor.h
)

set(UI
    lib/SearchBar.ui
)

# for distribution
set(HDRS_DISTRIB
    lib/qtermwidget.h
    lib/Emulation.h
    lib/Filter.h
    lib/Session.h
    lib/SessionManager.h
    lib/history/HistoryFile.h
    lib/history/HistoryScroll.h
    lib/history/HistoryScrollFile.h
    lib/history/HistoryScrollNone.h
    lib/history/HistoryType.h
    lib/history/HistoryTypeFile.h
    lib/history/HistoryTypeNone.h
    lib/history/compact/CompactHistoryScroll.h
    lib/history/compact/CompactHistoryType.h
    lib/BlockArray.h
    lib/Character.h
    lib/CharacterColor.h
    lib/TerminalDisplay.h
)

option(RUNDIR_KEYBOARD_LAYOUT_FIRST "Load keyboard layouts from application runtime directory" OFF)
if(CMAKE_BUILD_TYPE MATCHES Debug)
    set(RUNDIR_KEYBOARD_LAYOUT_FIRST ON) # enable runtime layouts loading for debug
endif()
message(STATUS "Use runtime directory keyboard layouts first: ${RUNDIR_KEYBOARD_LAYOUT_FIRST}")

# dirs
set(KB_LAYOUT_DIR "${CMAKE_INSTALL_FULL_DATADIR}/${TERMINALWIDGET_LIBRARY_NAME}/kb-layouts")
message(STATUS "Keyboard layouts will be installed in: ${KB_LAYOUT_DIR}")

set(COLORSCHEMES_DIR "${CMAKE_INSTALL_FULL_DATADIR}/${TERMINALWIDGET_LIBRARY_NAME}/color-schemes")
message(STATUS "Color schemes will be installed in: ${COLORSCHEMES_DIR}" )

set(TRANSLATIONS_DIR "${CMAKE_INSTALL_FULL_DATADIR}/${TERMINALWIDGET_LIBRARY_NAME}/translations")
message(STATUS "Translations will be installed in: ${TRANSLATIONS_DIR}")

set(TERMINALWIDGET_INCLUDE_DIR "${CMAKE_INSTALL_FULL_INCLUDEDIR}/${TERMINALWIDGET_LIBRARY_NAME}")

CHECK_FUNCTION_EXISTS(updwtmpx HAVE_UPDWTMPX)

qt5_wrap_cpp(MOCS ${HDRS})
qt5_wrap_ui(UI_SRCS ${UI})
set(PKG_CONFIG_REQ "Qt5Widgets")

lxqt_translate_ts(TERMINALWIDGET_QM
    TRANSLATION_DIR "lib/translations"
    UPDATE_TRANSLATIONS
        ${UPDATE_TRANSLATIONS}
    SOURCES
        ${SRCS} ${HDRS} ${UI}
    INSTALL_DIR
        ${TRANSLATIONS_DIR}
    COMPONENT
        Runtime
)

add_library(${TERMINALWIDGET_LIBRARY_NAME} SHARED ${SRCS} ${MOCS} ${UI_SRCS} ${TERMINALWIDGET_QM})
target_link_libraries(${TERMINALWIDGET_LIBRARY_NAME} Qt5::Widgets)
if (USE_TEST)
    #仅在单元测试模式下设置fvisibility为default
    target_compile_options(${TERMINALWIDGET_LIBRARY_NAME} PUBLIC "-fvisibility=default")
endif()
set_target_properties( ${TERMINALWIDGET_LIBRARY_NAME} PROPERTIES
                       SOVERSION ${TERMINALWIDGET_VERSION_MAJOR}
                       VERSION ${TERMINALWIDGET_VERSION}
                     )


if(APPLE)
    target_compile_definitions(${TERMINALWIDGET_LIBRARY_NAME}
        PRIVATE
            "HAVE_UTMPX"
            "UTMPX_COMPAT"
    )
endif()

if(HAVE_UPDWTMPX)
    target_compile_definitions(${TERMINALWIDGET_LIBRARY_NAME}
        PRIVATE
            "HAVE_UPDWTMPX"
    )
endif()

if (TERMINALWIDGET_USE_UTEMPTER)
    CHECK_INCLUDE_FILE(utempter.h HAVE_UTEMPTER)
    if (HAVE_UTEMPTER)
        target_compile_definitions(${TERMINALWIDGET_LIBRARY_NAME} PRIVATE
                "HAVE_UTEMPTER"
        )
        target_link_libraries(${TERMINALWIDGET_LIBRARY_NAME} ulog)
    endif()
endif()

if (UTF8PROC_FOUND)
    target_compile_definitions(${TERMINALWIDGET_LIBRARY_NAME}
        PRIVATE
            "HAVE_UTF8PROC"
    )
    target_include_directories(${TERMINALWIDGET_LIBRARY_NAME}
        INTERFACE
            ${UTF8PROC_INCLUDE_DIRS}
    )
    target_link_libraries(${TERMINALWIDGET_LIBRARY_NAME}
        ${UTF8PROC_LIBRARIES}
    )
    string(APPEND PKG_CONFIG_REQ ", libutf8proc")
endif()

if(APPLE)
    set (CMAKE_SKIP_RPATH 1)
    # this is a must to load the lib correctly
    set_target_properties(${TERMINALWIDGET_LIBRARY_NAME} PROPERTIES INSTALL_NAME_DIR ${CMAKE_INSTALL_FULL_LIBDIR})
endif()

target_compile_definitions(${TERMINALWIDGET_LIBRARY_NAME}
    PRIVATE
        "KB_LAYOUT_DIR=\"${KB_LAYOUT_DIR}\""
        "COLORSCHEMES_DIR=\"${COLORSCHEMES_DIR}\""
        "TRANSLATIONS_DIR=\"${TRANSLATIONS_DIR}\""
        "HAVE_POSIX_OPENPT"
        "HAVE_SYS_TIME_H"
        $<$<BOOL:${RUNDIR_KEYBOARD_LAYOUT_FIRST}>:RUNDIR_KEYBOARD_LAYOUT_FIRST>
)


generate_export_header(${TERMINALWIDGET_LIBRARY_NAME}
    EXPORT_FILE_NAME "${CMAKE_CURRENT_BINARY_DIR}/lib/qtermwidget_export.h"
    EXPORT_MACRO_NAME TERMINALWIDGET_EXPORT
)

target_include_directories(${TERMINALWIDGET_LIBRARY_NAME}
    PUBLIC
        "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib>"
        "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/lib>"
    INTERFACE
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${TERMINALWIDGET_LIBRARY_NAME}>"
)

write_basic_package_version_file(
    "${CMAKE_BINARY_DIR}/${TERMINALWIDGET_LIBRARY_NAME}-config-version.cmake"
    VERSION ${TERMINALWIDGET_VERSION}
    COMPATIBILITY AnyNewerVersion
)

install(FILES
    "${CMAKE_BINARY_DIR}/${TERMINALWIDGET_LIBRARY_NAME}-config-version.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${TERMINALWIDGET_LIBRARY_NAME}"
    COMPONENT Devel
)

install(EXPORT
    "${TERMINALWIDGET_LIBRARY_NAME}-targets"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${TERMINALWIDGET_LIBRARY_NAME}"
    COMPONENT Devel
)

install(FILES
    ${HDRS_DISTRIB} "${CMAKE_CURRENT_BINARY_DIR}/lib/qtermwidget_export.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${TERMINALWIDGET_LIBRARY_NAME}"
    COMPONENT Devel
)
# keyboard layouts
install(DIRECTORY
    lib/kb-layouts/
    DESTINATION "${KB_LAYOUT_DIR}"
    COMPONENT Runtime
    FILES_MATCHING PATTERN "*.keytab"
)

if(RUNDIR_KEYBOARD_LAYOUT_FIRST)
    file(COPY lib/kb-layouts/ DESTINATION ${CMAKE_BINARY_DIR}/kb-layouts)
endif()

# color schemes
install(DIRECTORY
    lib/color-schemes/
    DESTINATION "${COLORSCHEMES_DIR}"
    COMPONENT Runtime
    FILES_MATCHING PATTERN "*.*schem*"
)

lxqt_create_pkgconfig_file(
    PACKAGE_NAME ${TERMINALWIDGET_LIBRARY_NAME}
    DESCRIPTIVE_NAME ${TERMINALWIDGET_LIBRARY_NAME}
    DESCRIPTION "TerminalWidget library for Qt ${TERMINALWIDGET_VERSION_MAJOR}.x"
    INCLUDEDIRS ${TERMINALWIDGET_LIBRARY_NAME}
    LIBS ${TERMINALWIDGET_LIBRARY_NAME}
    REQUIRES ${PKG_CONFIG_REQ}
    VERSION ${TERMINALWIDGET_VERSION}
    INSTALL
    COMPONENT Devel
)

install(TARGETS ${TERMINALWIDGET_LIBRARY_NAME}
    DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    EXPORT "${TERMINALWIDGET_LIBRARY_NAME}-targets"
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    PUBLIC_HEADER
    COMPONENT Runtime
)

export(TARGETS ${TERMINALWIDGET_LIBRARY_NAME}
    FILE "${CMAKE_BINARY_DIR}/${TERMINALWIDGET_LIBRARY_NAME}-targets.cmake"
    EXPORT_LINK_INTERFACE_LIBRARIES
)
# end of main library

=== debian/changelog ===
deepin-terminal (6.0.16) unstable; urgency=medium

  * feat: Add debuginfod settings (#366)

 -- Yutao Meng <mengyutao@deepin.org>  Tue, 19 Nov 2024 10:05:41 +0800

## deepin-terminal 6.0.17

=== debian/changelog ===
deepin-terminal (6.0.17) unstable; urgency=medium

  * fix: crash on treeland (#378)

 -- Yutao Meng <mengyutao@deepin.org>  Sat, 07 Dec 2024 13:48:11 +0800

=== debian/control ===
Source: deepin-terminal
Section: utils
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.org>
Build-Depends:
 debhelper(>= 11),
 cmake,
 pkg-config,
 qtbase5-dev,
 qttools5-dev-tools,
 qtbase5-private-dev,
 libdtkwidget-dev,
 lxqt-build-tools(>= 0.6.0~),
 libglib2.0-dev,
 libsecret-1-dev,
 libgtest-dev,
 libgmock-dev,
 libxcb-ewmh-dev,
 fontconfig
Standards-Version: 4.5.1
Homepage: https://www.deepin.com/

Package: deepin-terminal
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 expect,
 zssh
Recommends: uos-reporter, deepin-event-log
Description: Terminal is an advanced terminal emulator with workspace, multiple
 windows, remote management, quake mode and other features.
 Terminal is a terminal emulator with simple interface, rich and powerful
 functions such as multi-windows, workspace, remote management, Quake mode
 and etc. You can instantly start and close Terminal smoothly like normal
 file window, allowing you to input commands with facility and no distractions.

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=5
export DH_VERBOSE=1
include /usr/share/dpkg/default.mk

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

%:
	dh $@ --parallel

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info -l/usr/lib

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_SAFETYTEST_ARG="CMAKE_SAFETYTEST_ARG_OFF" \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DVERSION=$(DEB_VERSION_UPSTREAM) \
	LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)
